# gcp::WidgetData Class Reference

`#include <widgetdata.h>`

List of all members.

## Public Member Functions

bool | IsSelected (gcu::Object const *obj) const
void | SetSelected (gcu::Object *obj)
void | Unselect (gcu::Object *obj)
void | UnselectAll ()
void | MoveSelectedItems (double dx, double dy)
void | MoveSelection (double dx, double dy)
void | RotateSelection (double x, double y, double angle)
void | ClearSelection ()
void | Copy (GtkClipboard *clipboard)
void | GetSelectionBounds (ArtDRect &rect) const
bool | HasSelection ()
void | SelectAll ()
void | ShowSelection (bool state)
void | GetObjectBounds (gcu::Object const *obj, ArtDRect *rect) const

## Static Public Member Functions

static xmlDocPtr | GetXmlDoc (GtkClipboard *clipboard)

## Public Attributes

View * | m_View
GtkWidget * | Canvas
GnomeCanvasGroup * | Group
GnomeCanvasItem * | Background
double | Zoom
std::map< gcu::Object const *, GnomeCanvasGroup * > | Items
std::list< gcu::Object * > | SelectedObjects

## Detailed Description

This class contains all data associated with a widget displaying a document. It might be deprecated in future versions since it was mostly useful for the Bonobo version which is not anymore supported.

Definition at line 73 of file widgetdata.h.

## Member Function Documentation

bool gcp::WidgetData::IsSelected | ( | gcu::Object const * | obj | ) | const

Parameters:

  | obj | an object.

Returns:
  true if the object is selected, false otherwise.

void gcp::WidgetData::SetSelected | ( | gcu::Object * | obj | ) |

Parameters:

  | obj | the object to select.

Selects the specified object.

void gcp::WidgetData::Unselect | ( | gcu::Object * | obj | ) |

Parameters:

  | obj | the object to unselect.

Unselects a specified object.

void gcp::WidgetData::UnselectAll | ( |  | ) |

Unselects everything.

void gcp::WidgetData::MoveSelectedItems | ( | double | dx,
|  | double | dy |
| ) |  |  |

Parameters:

  | dx | the x coordinate of the translation vector.
  | dy | the y coordinate of the translation vector.

Moves the items representing the selection, but don't move the objects themselves and don't modify the document. This is used by the selection tool but might be deprecated in the future.

void gcp::WidgetData::MoveSelection | ( | double | dx,
|  | double | dy |
| ) |  |  |

Parameters:

  | dx | the x coordinate of the translation vector.
  | dy | the y coordinate of the translation vector.

Moves the selection. This method creates an Operation instance for the Undo/Redo framework.

void gcp::WidgetData::RotateSelection | ( | double | x,
|  | double | y,
|  | double | angle |
| ) |  |  |

Parameters:

  | x | the x coordinate of the rotation center.
  | y | the y coordinate of the rotation center.
  | angle | the rotation angle.

Rotates the selection. This method does not create an Operation instance.

void gcp::WidgetData::ClearSelection | ( |  | ) | `[inline]`

Empties the list of selected objects. Called after objects have been deleted.

Definition at line 154 of file widgetdata.h.

References SelectedObjects.

void gcp::WidgetData::Copy | ( | GtkClipboard * | clipboard | ) |

Parameters:

  | clipboard | a GtkClipboard.

Copies the current selection to the clipboard.

void gcp::WidgetData::GetSelectionBounds | ( | ArtDRect & | rect | ) | const

Parameters:

  | rect | an ArtDRect which will receive the selection bounds.

Gets the selection bounds in canvas coordinates.

bool gcp::WidgetData::HasSelection | ( |  | ) | `[inline]`

Returns:
  true if at least one object is selected, false otherwise.

Definition at line 170 of file widgetdata.h.

References SelectedObjects.

void gcp::WidgetData::SelectAll | ( |  | ) |

Selects the whole document.

static xmlDocPtr gcp::WidgetData::GetXmlDoc | ( | GtkClipboard * | clipboard | ) | `[static]`

Parameters:

  | clipboard | a GtkClipboard.

Returns:
  the xmlDocPtr associtated with the clipboard.

void gcp::WidgetData::ShowSelection | ( | bool | state | ) |

Parameters:

  | state | whether to show or not the selection.

If state is true, the selection is highlighted, otherwise, it is displayed normally. This is used when printing or exporting an image.

void gcp::WidgetData::GetObjectBounds | ( | gcu::Object const * | obj,
|  | ArtDRect * | rect |
| ) |  |  | const

Parameters:

  | obj | a gcu::Object.
  | rect | an ArtDRect which will receive the object bounds.

Gets the object bounds in canvas coordinates.

## Member Data Documentation

View* gcp::WidgetData::m_View

The document view.

Definition at line 79 of file widgetdata.h.

GtkWidget* gcp::WidgetData::Canvas

The canvas widget to which this instance is associated.

Definition at line 83 of file widgetdata.h.

GnomeCanvasGroup* gcp::WidgetData::Group

The root group containing all other items, except the background.

Definition at line 87 of file widgetdata.h.

GnomeCanvasItem* gcp::WidgetData::Background

The white rectangle used as background (to be deprecated).

Definition at line 91 of file widgetdata.h.

double gcp::WidgetData::Zoom

The current zoom factor.

Definition at line 95 of file widgetdata.h.

std::map<gcu::Object const*, GnomeCanvasGroup*> gcp::WidgetData::Items

Maps the document objects to the canvas items which represent them.

Definition at line 99 of file widgetdata.h.

std::list<gcu::Object*> gcp::WidgetData::SelectedObjects

The list of selected objects.

Definition at line 103 of file widgetdata.h.

Referenced by ClearSelection(), and HasSelection().

The documentation for this class was generated from the following file:

- widgetdata.h